package cat.hack3.codingtests.marsrover.test.context;

import cat.hack3.codingtests.marsrover.api.cartography.Coordinates;
import cat.hack3.codingtests.marsrover.api.cartography.PlanetMap;

import java.util.List;

public abstract class GivenMarsMapSquaredWithInitialCoordinates implements TestingCommons {

    public static final Class<PlanetMap.Provider> PLANET_MAP_PROVIDER = PlanetMap.Provider.class;
    public static final List<Coordinates> NONE_OBSTACLE = List.of();

    protected PlanetMap marsMap;

    public void setUp() {
        int mapWidth = 10;
        int mapHeight = 10;
        int latitudeStartingPoint = 2;
        int longitudeStartingPoint = 3;
        var startingCoordinates = Coordinates.of(latitudeStartingPoint, longitudeStartingPoint);

        marsMap = getImplProviderOf(PLANET_MAP_PROVIDER)
                .provideWith(mapHeight, mapWidth, startingCoordinates, getObstacles());
    }

    protected List<Coordinates> getObstacles() {
        return NONE_OBSTACLE;
    }
}
